// CIS534 homework
// Author: Prof. Milo Martin
// University of Pennsylvania
// Spring 2010

#include "ppp.h"
#include "compute.h"
#include <math.h>

static int64_t distance(int64_t a, int64_t b) 
{
  if (a > b) {
    return a-b;
  } else {
    return b-a;
  }
}

void compute_one(int64_t num_particles, 
                 int64_t *location, 
                 int64_t *weight, 
                 int64_t *radius, 
                 int64_t *answer)
{
  // Computation 1
  if (ppp::get_thread_id() == 0) {
    for (int64_t i = 0; i < num_particles; i++) {
      for (int64_t j = 0; j < num_particles; j++) {
        if (distance(location[i], location[j]) < radius[i]) {
          answer[i] += weight[j];
        }
      }
    }
  }
}

void compute_two(int64_t num_particles, 
                 int64_t *location, 
                 int64_t *weight, 
                 int64_t *radius, 
                 int64_t *answer)
{
  // Computation 2
  if (ppp::get_thread_id() == 0) {
    for (int64_t i = 0; i < num_particles; i++) {
      for (int64_t j = 0; j < num_particles; j++) {
        if (distance(location[i], location[j]) < radius[i]) {
          answer[i] += (weight[i] + weight[j]) | distance(location[i], location[j]);
        }
      }
    }
  }
}

void compute_three(int64_t num_particles, 
                   int64_t *xlocation, 
                   int64_t *ylocation, 
                   int64_t *weight, 
                   int64_t radius, 
                   int64_t *answer)
{
  // Computation 3
  if (ppp::get_thread_id() == 0) {
    for (int64_t i = 0; i < num_particles; i++) {
      for (int64_t j = 0; j < num_particles; j++) {
        int64_t dist = distance(xlocation[i], xlocation[j]) + distance(ylocation[i], ylocation[j]);
        if (dist < radius) {
          answer[i] += (weight[i] + weight[j]) * dist;
        }
      }
    }
  }
}
