// Penn Parallel Primitives Library
// Author: Prof. Milo Martin
// University of Pennsylvania
// Spring 2010

#ifndef PPP_H
#define PPP_H

#include <stdlib.h>
#include <stdint.h>
#include <assert.h>

namespace ppp {
  namespace internal {
    extern __thread int s_thread_id;
    extern __thread int s_thread_count;
  }

  void init(void (*func) (void), int num_threads);
  extern inline int get_thread_id() { return internal::s_thread_id; }
  extern inline int get_thread_count() { return internal::s_thread_count; }
}

#endif
